#ifndef EETREQUEST_H
#define EETREQUEST_H

#include <QString>
#include <QDate>
#include <QUuid>
#include <QTimeZone>
#include <QSharedPointer>

#include "eetcpp_global.h"

#define NULL_VAL "__NULL__"

class EETCPPSHARED_EXPORT EetRequest : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString dat_odesl READ datOdeslStr)
    Q_PROPERTY(QString prvni_zaslani READ prvniZaslaniStr)
    Q_PROPERTY(QString uuid_zpravy READ uuidZpravyStr)
    Q_PROPERTY(QString overeni READ overeniStr)
    Q_PROPERTY(QString dic_popl READ dicPopl)
    Q_PROPERTY(QString dic_poverujiciho READ dicPoverujiciho)
    Q_PROPERTY(QString id_provoz READ idProvoz)
    Q_PROPERTY(QString id_pokl READ idPokl)
    Q_PROPERTY(QString porad_cis READ poradCis)
    Q_PROPERTY(QString dat_trzby READ datTrzbyStr)
    Q_PROPERTY(QString celk_trzba READ celkTrzbaStr)
    Q_PROPERTY(QString zakl_nepodl_dph READ zaklNepodlDphStr)
    Q_PROPERTY(QString zakl_dan1 READ zaklDan1Str)
    Q_PROPERTY(QString zakl_dan2 READ zaklDan2Str)
    Q_PROPERTY(QString zakl_dan3 READ zaklDan3Str)
    Q_PROPERTY(QString dan1 READ dan1Str)
    Q_PROPERTY(QString dan2 READ dan2Str)
    Q_PROPERTY(QString dan3 READ dan3Str)
    Q_PROPERTY(QString cest_sluz READ cestSluzStr)
    Q_PROPERTY(QString pouzit_zboz1 READ pouzitZboz1Str)
    Q_PROPERTY(QString pouzit_zboz2 READ pouzitZboz2Str)
    Q_PROPERTY(QString pouzit_zboz3 READ pouzitZboz3Str)
    Q_PROPERTY(QString urceno_cerp_zuct READ urcenoCerpZuctStr)
    Q_PROPERTY(QString cerp_zuct READ cerpZuctStr)
    Q_PROPERTY(QString rezim READ rezimStr)
public:
    explicit EetRequest(QObject *parent = 0);

    enum EetRezim {
        ZJEDNODUSENY = 0,
        STANDARD
    };

    QDateTime datOdesl() const;
    void setDatOdesl(const QDateTime &datOdesl);
    QString datOdeslStr() const;

    QTimeZone datOdeslZone() const;
    void setDatOdeslZone(const QTimeZone &datOdeslZone);
    QString datOdeslZoneStr() const;

    bool prvniZaslani() const;
    void setPrvniZaslani(bool prvniZaslani);
    QString prvniZaslaniStr() const;

    QUuid uuidZpravy() const;
    void setUuidZpravy(const QUuid &uuidZpravy);
    QString uuidZpravyStr() const;

    bool overeni() const;
    void setOvereni(bool overeni);
    QString overeniStr() const;

    QString dicPopl() const;
    void setDicPopl(const QString &dicPopl);

    QString dicPoverujiciho() const;
    void setDicPoverujiciho(const QString &dicPoverujiciho);

    QString idProvoz() const;
    void setIdProvoz(const QString &idProvoz);

    QString idPokl() const;
    void setIdPokl(const QString &idPokl);

    QString poradCis() const;
    void setPoradCis(const QString &poradCis);

    QDateTime datTrzby() const;
    void setDatTrzby(const QDateTime &datTrzby);
    QString datTrzbyStr() const;

    QTimeZone datTrzbyZone() const;
    void setDatTrzbyZone(const QTimeZone &datTrzbyZone);

    double celkTrzba() const;
    void setCelkTrzba(double celkTrzba);
    QString celkTrzbaStr() const;

    double zaklNepodlDph() const;
    void setZaklNepodlDph(double zaklNepodlDph);
    QString zaklNepodlDphStr() const;

    double zaklDan1() const;
    void setZaklDan1(double zaklDan1);
    QString zaklDan1Str() const;

    double dan1() const;
    void setDan1(double dan1);
    QString dan1Str() const;

    double zaklDan2() const;
    void setZaklDan2(double zaklDan2);
    QString zaklDan2Str() const;

    double dan2() const;
    void setDan2(double dan2);
    QString dan2Str() const;

    double zaklDan3() const;
    void setZaklDan3(double zaklDan3);
    QString zaklDan3Str() const;

    double dan3() const;
    void setDan3(double dan3);
    QString dan3Str() const;

    double cestSluz() const;
    void setCestSluz(double cestSluz);
    QString cestSluzStr() const;

    double pouzitZboz1() const;
    void setPouzitZboz1(double pouzitZboz1);
    QString pouzitZboz1Str() const;

    double pouzitZboz2() const;
    void setPouzitZboz2(double pouzitZboz2);
    QString pouzitZboz2Str() const;

    double pouzitZboz3() const;
    void setPouzitZboz3(double pouzitZboz3);
    QString pouzitZboz3Str() const;

    double urcenoCerpZuct() const;
    void setUrcenoCerpZuct(double urcenoCerpZuct);
    QString urcenoCerpZuctStr() const;

    double cerpZuct() const;
    void setCerpZuct(double cerpZuct);
    QString cerpZuctStr() const;

    EetRezim rezim() const;
    void setRezim(const EetRezim &rezim);
    QString rezimStr() const;

private:
    QDateTime m_datOdesl;
    QTimeZone m_datOdeslZone;
    bool m_prvniZaslani;
    QUuid m_uuidZpravy;
    QSharedPointer<bool> m_overeni;
    QSharedPointer<QString> m_dicPopl;
    QSharedPointer<QString> m_dicPoverujiciho;
    QString m_idProvoz;
    QString m_idPokl;
    QString m_poradCis;
    QDateTime m_datTrzby;
    QTimeZone m_datTrzbyZone;
    QSharedPointer<double> m_celkTrzba;
    QSharedPointer<double> m_zaklNepodlDph;
    QSharedPointer<double> m_zaklDan1;
    QSharedPointer<double> m_dan1;
    QSharedPointer<double> m_zaklDan2;
    QSharedPointer<double> m_dan2;
    QSharedPointer<double> m_zaklDan3;
    QSharedPointer<double> m_dan3;
    QSharedPointer<double> m_cestSluz;
    QSharedPointer<double> m_pouzitZboz1;
    QSharedPointer<double> m_pouzitZboz2;
    QSharedPointer<double> m_pouzitZboz3;
    QSharedPointer<double> m_urcenoCerpZuct;
    QSharedPointer<double> m_cerpZuct;
    EetRezim m_rezim;

signals:

public slots:
};

#endif // EETREQUEST_H
