#include "eetresult.h"

EetResult::EetResult(QObject *parent) : QObject(parent)
{
    m_status = RESPONSE_OK;
}

EetResult::ResponseStatus EetResult::status() const
{
    return m_status;
}

void EetResult::setStatus(const EetResult::ResponseStatus &status)
{
    m_status = status;
}

QString EetResult::fik() const
{
    return m_fik;
}

void EetResult::setFik(const QString &fik)
{
    m_fik = fik;
}

EetMessageList EetResult::warnings() const
{
    return m_warnings;
}

void EetResult::setWarnings(const EetMessageList &warnings)
{
    m_warnings = warnings;
}

EetMessageList EetResult::errors() const
{
    return m_errors;
}

void EetResult::setErrors(const EetMessageList &errors)
{
    m_errors = errors;
}

QUuid EetResult::uuid() const
{
    return m_uuid;
}

void EetResult::setUuid(const QUuid &uuid)
{
    m_uuid = uuid;
}

QDateTime EetResult::reciveDate() const
{
    return m_reciveDate;
}

void EetResult::setReciveDate(const QDateTime &reciveDate)
{
    m_reciveDate = reciveDate;
}

QString EetResult::pkp() const
{
    return m_pkp;
}

void EetResult::setPkp(const QString &pkp)
{
    m_pkp = pkp;
}

QString EetResult::bkp() const
{
    return m_bkp;
}

void EetResult::setBkp(const QString &bkp)
{
    m_bkp = bkp;
}

EetMessage::EetMessage(QObject *parent)
    :QObject(parent)
{
    m_code = 0;
}

EetMessage::EetMessage(int code, const QString &message, QObject *parent)
    :QObject(parent)
{
    m_code = code;
    m_message = message;
}

int EetMessage::code() const
{
    return m_code;
}

void EetMessage::setCode(int code)
{
    m_code = code;
}

QString EetMessage::message() const
{
    return m_message;
}

void EetMessage::setMessage(const QString &message)
{
    m_message = message;
}
